function iniateStupidHealers()
	--print("StupidHealers iniated.")
	--print("FrameX loaded: ", stupidHealerFrameX)
	--print("FrameY loaded: ", stupidHealerFrameY)
	--print("Rank loaded: ", stupidHealerPlayerPrestigeRank)
	--print("Rank loaded: ", stupidHealerPlayerPrestigeNeeded)
	createStupidHealersUI()
	setStupidHealersVariables()
	setStupidHealersUI()
	print("StupidHealers ready for abuse.")
end
function vardump(value, depth, key)
  local linePrefix = ""
  local spaces = ""
  
  if key ~= nil then
    linePrefix = "["..key.."] = "
  end
  
  if depth == nil then
    depth = 0
  else
    depth = depth + 1
    for i=1, depth do spaces = spaces .. "  " end
  end
  
  if type(value) == 'table' then
    mTable = getmetatable(value)
    if mTable == nil then
      print(spaces ..linePrefix.."(table) ")
    else
      print(spaces .."(metatable) ")
        value = mTable
    end		
    for tableKey, tableValue in pairs(value) do
      vardump(tableValue, depth, tableKey)
    end
  elseif type(value)	== 'function' or 
      type(value)	== 'thread' or 
      type(value)	== 'userdata' or
      value		== nil
  then
    print(spaces..tostring(value))
  else
    print(spaces..linePrefix.."("..type(value)..") "..tostring(value))
  end
end

function Target(target)
	return Inspect.Unit.Detail(target)
end


function Zone(target)
	return Inspect.Zone.Detail(target)
end

function stupidHealerZoneChange()
		stupidHealerPlayerPrestigeNeeded = Inspect.Pvp.Prestige().needed
		stupidHealerPlayerPrestigeRank = Inspect.Pvp.Prestige().rank
		if Zone(Target("player")).zone.type == 'warfront' then
			getHeals = true
			player = Target("player")
			zone = Zone(player.zone)
			pvpHeader:SetText(zone.name)
			pvpHealer1:SetText("")
			pvpHealer2:SetText("")
			pvpHealer3:SetText("")
			resetHealers()
		else
			getHeals = false
			pvpHeader:SetText("PVP Stats")
			pvpHealer1:SetText(getPrestige("rank"))
			pvpHealer2:SetText(getPrestige("needed"))
			pvpHealer3:SetText("")
		end
end

function updateHeals(data)
	if getHeals then
		if data ~= nil then
			if data.heal == nil then return	else
				t = Target(data.caster)
				if t ~= nil then 
					if t.relation == 'hostile' then
						healerFound = 0
						healer = Target(data.caster).name
						healed = {healer, data.heal}
						for row,value in ipairs(thoseStupidHealers) do
							name = value[1]
							i = value[2]
							if name == healer then
								healerFound = 1
								healerSlot = row
								break;
							end
						end
						if healerFound == 1 then
							if healer ~= nil and data.heal ~= nil then
								thoseStupidHealers[healerSlot][2] = thoseStupidHealers[healerSlot][2] + data.heal
							else
								print("attempting nil value!")
							end
						else
							table.insert(thoseStupidHealers, healed)
						end
						updateStupidHealersFrame()
					end
				end
			end	
		else
			print("attempting data = nil!")
		end
	end
end

function updateStupidHealersFrame()
	table.sort(thoseStupidHealers, function(a,b) return a[2] > b[2] end)
	pvpHealer1:SetText("#1 "..thoseStupidHealers[1][1].." - "..tostring(thoseStupidHealers[1][2]))
	--targetThatStupidHealer(pvpHealer1, 1)
	
	if thoseStupidHealers[2] then
		pvpHealer2:SetText("#2 "..thoseStupidHealers[2][1].." - "..tostring(thoseStupidHealers[2][2]))
		--targetThatStupidHealer(pvpHealer2, 2)
	end
	if thoseStupidHealers[3] then
		pvpHealer3:SetText("#3 "..thoseStupidHealers[3][1].." - "..tostring(thoseStupidHealers[3][2]))
		--targetThatStupidHealer(pvpHealer3, 3)
	end
	--vardump(thoseStupidHealers)
end


function createStupidHealersUI()
	context = UI.CreateContext("HealFrame")
	pvpFrame = UI.CreateFrame("Frame", "SHFrame", context)
	pvpHeader = UI.CreateFrame("Text", "Header", context)
	pvpHealer1 = UI.CreateFrame("Text", "H1", context)
	pvpHealer2 = UI.CreateFrame("Text", "H2", context)
	pvpHealer3 = UI.CreateFrame("Text", "H3", context)

end


function setStupidHealersUI()
	-- SH Mainframe
	pvpFrame:SetPoint("TOPCENTER", UIParent, "TOPLEFT", tonumber(SHframeX), tonumber(SHframeY))
	pvpFrame:SetHeight(stupidHealerFrameHeight)
	pvpFrame:SetWidth(200)
	pvpFrame:SetBackgroundColor(0,0,0)
	pvpFrame:SetAlpha(1)
	
	-- SH Header
	pvpHeader:SetPoint("TOPCENTER", pvpFrame, "TOPCENTER", 0, 10)
	pvpHeader:SetText("PVP Stats")
	pvpHeader:SetParent(pvpFrame)
	moveThemHealers(pvpHeader)

	-- SH Healers
	pvpHealer1:SetPoint("CENTER", pvpFrame, "CENTER", 0, -10)
	pvpHealer1:SetText(getPrestige("rank"))
	pvpHealer1:SetParent(pvpFrame)

	pvpHealer2:SetPoint("CENTER", pvpFrame, "CENTER", 0, 10)
	pvpHealer2:SetText(getPrestige("needed"))
	pvpHealer2:SetParent(pvpFrame)

	pvpHealer3:SetPoint("CENTER", pvpFrame, "CENTER", 0, 30)
	pvpHealer3:SetText("")
	pvpHealer3:SetParent(pvpFrame)

end

function getPrestige(s)
	if Inspect.Pvp.Prestige() ~= nil then
		if s == "rank" then
			if Inspect.Pvp.Prestige().rank ~= nil then
				return "Prestige rank: "..Inspect.Pvp.Prestige().rank
			else
				return "Rank not available"
			end
		elseif s == "needed" then
			if Inspect.Pvp.Prestige().needed ~= nil then
				return "Needed for next: "..Inspect.Pvp.Prestige().needed
			else
				return "Prestige needed not available"
			end
		else
			return "error"
		end
	else
		if s == "rank" then
			if stupidHealerPlayerPrestigeRank ~= nil then
				return "Prestige rank: "..prestigeRank
			else
				return "Prestige rank: N/A"
			end
		elseif s == "needed" then
			if stupidHealerPlayerPrestigeNeeded ~= nil then
				return "Prestige needed: "..prestigeNeeded
			else
				return "Prestige needed: N/A"
			end
		end		
	end
end

function setStupidHealersVariables()
	mouseDown = false
	getHeals = true
	thoseStupidHealers = {}
	stupidHealerFrameWidth = 200
	stupidHealerFrameHeight = 100 --pvpHeader:GetHeight() + pvpHealer1:GetHeight() + pvpHealer2:GetHeight() + pvpHealer3:GetHeight()
	if stupidHealerFrameX then SHframeX = stupidHealerFrameX else SHframeX = 0 end
	if stupidHealerFrameY then SHframeY = stupidHealerFrameY else SHframeY = 0 end
	if stupidHealerPlayerPrestigeNeeded then prestigeNeeded = stupidHealerPlayerPrestigeNeeded else prestigeNeeded = 0 end
	if stupidHealerPlayerPrestigeRank then prestigeRank = stupidHealerPlayerPrestigeRank else prestigeRank = 0 end
	--print("Variables:")
	--print(SHframeX)
	--print(SHframeY)
	
end

function targetThatStupidHealer(target, player)
	target:SetSecureMode("restricted")
	target:EventAttach(Event.UI.Input.Mouse.Left.Click, "target "..thoseStupidHealers[player][1], "Target player")
	
end

function showStupidHealers()
	pvpFrame:SetAlpha(1)
end
function hideStupidHealers()
	pvpFrame:SetAlpha(0)
end

function moveThemHealers(target)
	frame = target:GetParent()
	function target.Event:LeftDown()
		mouseDown = true
	end
	function target.Event:LeftUp()
		mouseDown = false
	end
	function target.Event:LeftUpoutside()
		mouseDown = false
	end
	function target.Event:MouseMove()
		if mouseDown then
			SHmouse = Inspect.Mouse()
			SHnewY = SHmouse.y
			SHnewX = SHmouse.x
			frame:ClearAll()
			frame:SetPoint("TOPCENTER", UIParent, "TOPLEFT", tonumber(SHnewX), tonumber(SHnewY))
			frame:SetWidth(stupidHealerFrameWidth)
			frame:SetHeight(stupidHealerFrameHeight)
			stupidHealerFrameX = SHnewX
			stupidHealerFrameY = SHnewY					
		end
	end
end
function resetHealers()
	thoseStupidHealers = {}
	pvpHealer1:SetText("#1")
	pvpHealer2:SetText("#2")
	pvpHealer3:SetText("#3")
end
function showMe(cmd)
	vardump(Target("player"))
	vardump(Zone(Target("player").zone))
end
function showSHUI(cmd)
	showStupidHealers()
end

function hideSHUI(cmd)
	hideStupidHealers()
end

table.insert(Event.Combat.Heal, {updateHeals, "StupidHealers", "Heals"})
table.insert(Command.Slash.Register("myinfo"), {showMe, "StupidHealers", "myInfo"})
table.insert(Command.Slash.Register("showsh"), {showSHUI, "StupidHealers", "showSH"})
table.insert(Command.Slash.Register("hidesh"), {hideSHUI, "StupidHealers", "hideSH"})
table.insert(Command.Slash.Register("rsh"), {resetHealers, "StupidHealers", "resetThem"})
table.insert(Event.Unit.Detail.Zone, {stupidHealerZoneChange, "StupidHealers", "Warfront"})
table.insert(Event.Addon.SavedVariables.Load.End, {iniateStupidHealers, "StupidHealers", "Launch"})
